// MyWindowInfoDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "ProcessView.h"
#include "MyWindowInfoDlg.h"
#include "afxdialogex.h"


// CMyWindowInfoDlg Ի

IMPLEMENT_DYNAMIC(CMyWindowInfoDlg, CDialogEx)

CMyWindowInfoDlg::CMyWindowInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_DIALOG2, pParent)
{

}

CMyWindowInfoDlg::~CMyWindowInfoDlg()
{
}

void CMyWindowInfoDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialogEx::DoDataExchange(pDX);
    DDX_Control(pDX, LST_WINDOW, m_ListCtrl);
}


BEGIN_MESSAGE_MAP(CMyWindowInfoDlg, CDialogEx)
END_MESSAGE_MAP()


// CMyWindowInfoDlg Ϣ


//ýID
void CMyWindowInfoDlg::SetProcessId(DWORD ProcessId)
{
    m_ProcessId = ProcessId;
}


//ȡID
DWORD CMyWindowInfoDlg::GetProcessId() const
{
    return m_ProcessId;
}


//ȡϢ
void CMyWindowInfoDlg::GetWindowInfo()
{
    EnumWindows(EnumWindowsProc, (LPARAM)this);
}


//öٴڻص
BOOL CALLBACK CMyWindowInfoDlg::EnumWindowsProc(HWND hwnd, LPARAM lParam)
{
    CMyWindowInfoDlg *pThis = (CMyWindowInfoDlg *)lParam;

    CString csFmt;
    DWORD dwProcessId = 0;
    DWORD dwThreadId = 0;

    //ȡڵĽID߳ID
    dwThreadId = GetWindowThreadProcessId(hwnd, &dwProcessId);

    if (dwProcessId == pThis->m_ProcessId)
    {
        //ȡ
        int nRows = pThis->m_ListCtrl.GetItemCount();

        //ʾھ
        csFmt.Format(_T("0x%08X"), hwnd);
        pThis->m_ListCtrl.InsertItem(nRows, csFmt);

        //ʾڱ
        TCHAR szWndText[MAX_PATH] = { 0 };
        ::GetWindowText(hwnd, szWndText, MAX_PATH);
        pThis->m_ListCtrl.SetItemText(nRows, 1, szWndText);

        //ʾ
        TCHAR szWndClassName[MAX_PATH] = { 0 };
        ::GetClassName(hwnd, szWndClassName, MAX_PATH);
        pThis->m_ListCtrl.SetItemText(nRows, 2, szWndClassName);

        //ʾID
        csFmt.Format(_T("%d"), dwProcessId);
        pThis->m_ListCtrl.SetItemText(nRows, 3, csFmt);

        //ʾ߳ID
        csFmt.Format(_T("%d"), dwThreadId);
        pThis->m_ListCtrl.SetItemText(nRows, 4, csFmt);
    }

    return TRUE;
}


//ʼ
BOOL CMyWindowInfoDlg::OnInitDialog()
{
    CDialogEx::OnInitDialog();

    //ListCtrl
    m_ListCtrl.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

    //ӱͷ
    m_ListCtrl.InsertColumn(0, _T("ھ"), LVCFMT_LEFT, 120);
    m_ListCtrl.InsertColumn(1, _T("ڱ"), LVCFMT_LEFT, 250);
    m_ListCtrl.InsertColumn(2, _T(""), LVCFMT_LEFT, 250);
    m_ListCtrl.InsertColumn(3, _T("Id"), LVCFMT_LEFT, 115);
    m_ListCtrl.InsertColumn(4, _T("߳Id"), LVCFMT_LEFT, 115);

    //ȡϢӵб
    GetWindowInfo();

    return TRUE;  // return TRUE unless you set the focus to a control
                  // 쳣: OCX ҳӦ FALSE
}
