
// ProcessViewDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "ProcessView.h"
#include "ProcessViewDlg.h"
#include "afxdialogex.h"
#include <Tlhelp32.h>
#include "MyModuleInfoDlg.h"
#include "MyWindowInfoDlg.h"
#include "MyThreadInfoDlg.h"
#include "MyRemoteDllDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Ի
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CProcessViewDlg Ի



CProcessViewDlg::CProcessViewDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_PROCESSVIEW_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    m_dwProcessId = 0;
    m_ListSelectItem = -1;
}

void CProcessViewDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialogEx::DoDataExchange(pDX);
    DDX_Control(pDX, LST_PROCESS, m_ListCtrl);
}

BEGIN_MESSAGE_MAP(CProcessViewDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
    ON_NOTIFY(NM_RCLICK, LST_PROCESS, &CProcessViewDlg::OnRclickLstProcess)
    ON_COMMAND(MN_PROCESS_REFRESH, &CProcessViewDlg::OnProcessRefresh)
    ON_COMMAND(MN_PROCESS_MODULE, &CProcessViewDlg::OnProcessModule)
    ON_COMMAND(MN_PROCESS_THREAD, &CProcessViewDlg::OnProcessThread)
    ON_COMMAND(MN_PROCESS_WINDOW, &CProcessViewDlg::OnProcessWindow)
    ON_COMMAND(MN_PROCESS_EXIT, &CProcessViewDlg::OnProcessExit)
    ON_COMMAND(MN_DLLINJECT, &CProcessViewDlg::OnDllinject)
END_MESSAGE_MAP()


// CProcessViewDlg Ϣ

BOOL CProcessViewDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶Իͼꡣ  ӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

    //ListCtrl
    m_ListCtrl.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

	//ӱͷ
    m_ListCtrl.InsertColumn(0, _T("ӳ"), LVCFMT_LEFT, 290);
    m_ListCtrl.InsertColumn(1, _T("ID"), LVCFMT_LEFT, 170);
    m_ListCtrl.InsertColumn(2, _T("ID"), LVCFMT_LEFT, 170);
    m_ListCtrl.InsertColumn(3, _T("ӳ·"), LVCFMT_LEFT, 500);

    //̣ӵб
    GetProcessInfo();

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CProcessViewDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣ  ʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CProcessViewDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CProcessViewDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


//Ϣӵбؼ
void CProcessViewDlg::GetProcessInfo()
{
    //Ľ̿
    HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

    //ȡʧܣֱӷ
    if (INVALID_HANDLE_VALUE == hSnapshot)
    {
        return;
    }

    PROCESSENTRY32 pe32 = { 0 };
    pe32.dwSize = sizeof(PROCESSENTRY32);

    //
    if (Process32First(hSnapshot, &pe32))
    {
        int nRow = 0;
        CString strFmt;

        do 
        {
            //б
            m_ListCtrl.InsertItem(nRow, pe32.szExeFile);
            m_ListCtrl.SetItemData(nRow, pe32.th32ProcessID);

            //IDб
            strFmt.Format(_T("%d"), pe32.th32ProcessID);
            m_ListCtrl.SetItemText(nRow, 1, strFmt);

            //IDб
            strFmt.Format(_T("%d"), pe32.th32ParentProcessID);
            m_ListCtrl.SetItemText(nRow, 2, strFmt);

            //ȡ·
            HANDLE hProcess = ::OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);

            if (hProcess != NULL)
            {
                TCHAR szBuff[MAX_PATH] = { 0 };
                DWORD dwSize = MAX_PATH;

                if (::QueryFullProcessImageName(hProcess, 0, szBuff, &dwSize))
                {
                    m_ListCtrl.SetItemText(nRow, 3, szBuff);
                }
            }

            nRow++;
        } while (Process32Next(hSnapshot, &pe32));
    }

    //رվ
    CloseHandle(hSnapshot);
}



//ӦҼϢ
void CProcessViewDlg::OnRclickLstProcess(NMHDR *pNMHDR, LRESULT *pResult)
{
    LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
    *pResult = 0;

    //ڿؼ
    m_ListCtrl.ClientToScreen(&pNMItemActivate->ptAction);

    //ز˵
    CMenu menu;
    menu.LoadMenu(MN_PROCESSMENU);

    //ȡӲ˵
    CMenu *pSubMenu = menu.GetSubMenu(0);

    //жûǷѡбеĳ
    if (-1 != pNMItemActivate->iItem)
    {
        m_ListSelectItem = pNMItemActivate->iItem;
        m_dwProcessId = m_ListCtrl.GetItemData(pNMItemActivate->iItem);
    }
    else
    {
        m_dwProcessId = 0;
        
        //ˢ¡ʹ˵ѡɫ
        pSubMenu->EnableMenuItem(MN_PROCESS_MODULE, MF_GRAYED);
        pSubMenu->EnableMenuItem(MN_PROCESS_THREAD, MF_GRAYED);
        pSubMenu->EnableMenuItem(MN_PROCESS_WINDOW, MF_GRAYED);
        pSubMenu->EnableMenuItem(MN_PROCESS_EXIT, MF_GRAYED);
    }

    //Ӳ˵
    pSubMenu->TrackPopupMenu(TPM_LEFTALIGN, pNMItemActivate->ptAction.x, pNMItemActivate->ptAction.y, this);
}


//Ӧ˵ˢϢ
void CProcessViewDlg::OnProcessRefresh()
{
    //б
    m_ListCtrl.DeleteAllItems();

    //±
    GetProcessInfo();
}


//Ӧ˵Ĳ鿴ģϢ
void CProcessViewDlg::OnProcessModule()
{
    CMyModuleInfoDlg ModuleDlg;
    ModuleDlg.SetProcessId(m_dwProcessId);
    ModuleDlg.DoModal();
}


//Ӧ˵Ĳ鿴߳Ϣ
void CProcessViewDlg::OnProcessThread()
{
    CMyThreadInfoDlg ThreadDlg;
    ThreadDlg.SetProcessId(m_dwProcessId);
    ThreadDlg.DoModal();
}


//Ӧ˵Ĳ鿴̴Ϣ
void CProcessViewDlg::OnProcessWindow()
{
    CMyWindowInfoDlg WindowDlg;
    WindowDlg.SetProcessId(m_dwProcessId);
    WindowDlg.DoModal();
}


//Ӧ˵ĽϢ
void CProcessViewDlg::OnProcessExit()
{
    //򿪽̣ȡ̾
    HANDLE hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, m_dwProcessId);

    //ǿƽ
    BOOL bRet = TerminateProcess(hProcess, 0);

    if (!bRet)
    {
        MessageBox(_T("ʧ"), _T("ʾ"), MB_OK);
        return;
    }

    //бɾص
    m_ListCtrl.DeleteItem(m_ListSelectItem);
}


//Ӧ˵DLLעϢ
void CProcessViewDlg::OnDllinject()
{
    CMyRemoteDllDlg RemoteDllDlg;
    RemoteDllDlg.SetProcessId(m_dwProcessId);
    RemoteDllDlg.DoModal();
}
